/*************************************************************************
Copyright (C) 2008 Novell, Inc. All Rights Reserved. 

THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND 
TREATIES. USE AND REDISTRIBUTION OF THIS WORK IS SUBJECT TO THE LICENSE
AGREEMENT ACCOMPANYING THE SOFTWARE DEVELOPMENT KIT (SDK) THAT CONTAINS
THIS WORK. PURSUANT TO THE SDK LICENSE AGREEMENT, NOVELL HEREBY GRANTS
TO DEVELOPER A ROYALTY-FREE, NON-EXCLUSIVE LICENSE TO INCLUDE NOVELL'S
SAMPLE CODE IN ITS PRODUCT. NOVELL GRANTS DEVELOPER WORLDWIDE DISTRIBUTION
RIGHTS TO MARKET, DISTRIBUTE, OR SELL NOVELL'S SAMPLE CODE AS A COMPONENT
OF DEVELOPER'S PRODUCTS. NOVELL SHALL HAVE NO OBLIGATIONS TO DEVELOPER OR
DEVELOPER'S CUSTOMERS WITH RESPECT TO THIS CODE.

***************************************************************************/
/*******************************************************************
* Name: interface_types.h
* Description: define a C/C++ interface for the Document Object Model
* level 1 core functionality
* Tabs: 4
*******************************************************************/
#ifndef _INTERFACE_TYPES_H_
#define	_INTERFACE_TYPES_H_

#if	defined(_WINDOWS)
///* need ptrdiff_t definition */
#include	<crtdefs.h>
#endif

#if	defined(UNIX)
///* need ptrdiff_t definition */
#include	<malloc.h>
#endif

/* UTF-16 character type */
typedef unsigned short	unicode;

/* signed type to use for memory offsets and indexes */
#ifndef	_S_INDEX_T_DEFINED_
typedef	ptrdiff_t		s_index_t;
#define	INVALID_S_INDEX_T	((s_index_t)-1)
#define	_S_INDEX_T_DEFINED_
#endif
/* unsigned type to use for memory offsets and indexes */
#ifndef	_U_INDEX_T_DEFINED_
typedef	size_t	u_index_t;
//FIXIT: change this to MAX_INT sort of thing
#define	INVALID_U_INDEX_T	((u_index_t)-1)
#define	_U_INDEX_T_DEFINED_
#endif

#endif	/* #ifndef _INTERFACE_TYPES_H_ */

